diff --git a/src/main/java/net/minecraft/core/net/packet/Packet1Login.java b/src/main/java/net/minecraft/core/net/packet/LoginPacket.java
similarity index 72%
rename from src/main/java/net/minecraft/core/net/packet/Packet1Login.java
rename to src/main/java/net/minecraft/core/net/packet/LoginPacket.java
index dc5646db0..70005a373 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet1Login.java
+++ b/src/main/java/net/minecraft/core/net/packet/LoginPacket.java
@@ -1,20 +1,27 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet1Login extends Packet
+public class LoginPacket extends Packet
 {
+    public int playerEntityIdAndProtocolVersion;
+    public String username;
+    public long worldSeed;
+    public byte dimensionId;
+    public byte worldTypeId;
+    public int packetDelay;
+    public String publicKey;
 
-    public Packet1Login()
+    public LoginPacket()
     {
     }
 
-    public Packet1Login(String username, int playerEntityIdOrProtocolVersion, long worldSeed, byte dimensionId, byte worldTypeId, int packetDelay, String publicKey)
+    public LoginPacket(String username, int playerEntityIdOrProtocolVersion, long worldSeed, byte dimensionId, byte worldTypeId, int packetDelay, String publicKey)
     {
         this.username = username;
         this.playerEntityIdAndProtocolVersion = playerEntityIdOrProtocolVersion;
@@ -25,7 +32,7 @@ public class Packet1Login extends Packet
         this.publicKey = publicKey;
     }
 
-    public Packet1Login(String s, int i, String p)
+    public LoginPacket(String s, int i, String p)
     {
         username = s;
         playerEntityIdAndProtocolVersion = i;
@@ -33,7 +40,7 @@ public class Packet1Login extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         playerEntityIdAndProtocolVersion = dis.readInt();
@@ -46,7 +53,7 @@ public class Packet1Login extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(playerEntityIdAndProtocolVersion);
@@ -59,22 +66,14 @@ public class Packet1Login extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleLogin(this);
+        packetHandler.handleLogin(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 4 + username.length() + 8 + 1 + 1 + 1;
     }
-
-    public int playerEntityIdAndProtocolVersion;
-    public String username;
-    public long worldSeed;
-    public byte dimensionId;
-    public byte worldTypeId;
-    public int packetDelay;
-    public String publicKey;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet131MapData.java b/src/main/java/net/minecraft/core/net/packet/MapDataPacket.java
similarity index 64%
rename from src/main/java/net/minecraft/core/net/packet/Packet131MapData.java
rename to src/main/java/net/minecraft/core/net/packet/MapDataPacket.java
index b6e55672a..e7d752ddc 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet131MapData.java
+++ b/src/main/java/net/minecraft/core/net/packet/MapDataPacket.java
@@ -1,35 +1,39 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.world.saveddata.maps.MapWaypoint;
 
 import java.io.*;
 import java.util.ArrayList;
 import java.util.List;
 
-public class Packet131MapData extends Packet {
+public class MapDataPacket extends Packet {
 
 	public short itemId;
 	public short meta;
+	public byte scale;
 	public byte[] mapData;
 	public List<MapWaypoint> waypoints;
 
-	public Packet131MapData() {
+	public MapDataPacket() {
 		this.isChunkDataPacket = true;
 	}
 
-	public Packet131MapData(short itemId, short meta, byte[] mapData, List<MapWaypoint> waypoints) {
+	public MapDataPacket(short itemId, short meta, byte scale, byte[] mapData, List<MapWaypoint> waypoints) {
 		this.isChunkDataPacket = true;
 		this.itemId = itemId;
+		this.scale = scale;
 		this.meta = meta;
 		this.waypoints = waypoints;
 		this.mapData = mapData;
+		this.scale = scale;
 	}
 
 	@Override
-	public void readPacketData(DataInputStream dis) throws IOException {
+	public void read(DataInputStream dis) throws IOException {
 		this.itemId = dis.readShort();
 		this.meta = dis.readShort();
+		this.scale = dis.readByte();
 
 		int wayPointAmount = dis.readByte();
 		this.waypoints = new ArrayList<>();
@@ -42,10 +46,11 @@ public class Packet131MapData extends Packet {
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream dos) throws IOException {
+	public void write(DataOutputStream dos) throws IOException {
 		dos.writeShort(itemId);
 		dos.writeShort(meta);
-		
+		dos.writeByte(scale);
+
 		dos.writeByte(waypoints.size());
 		for (int i = 0; i < ((byte)waypoints.size()); i++) {
 			waypoints.get(i).writeToOutputStream(dos);
@@ -56,12 +61,12 @@ public class Packet131MapData extends Packet {
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleMapData(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleMapData(this);
 	}
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return 4 + mapData.length;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/MoveEntityPacket.java b/src/main/java/net/minecraft/core/net/packet/MoveEntityPacket.java
new file mode 100644
index 000000000..2fc7c642b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/MoveEntityPacket.java
@@ -0,0 +1,188 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class MoveEntityPacket extends Packet
+{
+    public int id;
+    public byte x;
+    public byte y;
+    public byte z;
+    public byte yaw;
+    public byte pitch;
+    public boolean rotating;
+
+    public MoveEntityPacket()
+    {
+        rotating = false;
+    }
+    
+    public MoveEntityPacket(int i)
+    {
+        rotating = false;
+        id = i;
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        id = dis.readInt();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeInt(id);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleEntity(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 4;
+    }
+
+    public static class Pos extends MoveEntityPacket
+    {
+
+        public Pos()
+        {
+        }
+
+        public Pos(int i, byte byte0, byte byte1, byte byte2)
+        {
+            super(i);
+            x = byte0;
+            y = byte1;
+            z = byte2;
+        }
+
+        @Override
+        public void read(DataInputStream dis)
+            throws IOException
+        {
+            super.read(dis);
+            x = dis.readByte();
+            y = dis.readByte();
+            z = dis.readByte();
+        }
+
+        @Override
+        public void write(DataOutputStream dos)
+            throws IOException
+        {
+            super.write(dos);
+            dos.writeByte(x);
+            dos.writeByte(y);
+            dos.writeByte(z);
+        }
+
+        @Override
+        public int getEstimatedSize()
+        {
+            return 7;
+        }
+    }
+
+    public static class Rot extends MoveEntityPacket
+    {
+
+        public Rot()
+        {
+            rotating = true;
+        }
+
+        public Rot(int i, byte byte0, byte byte1)
+        {
+            super(i);
+            yaw = byte0;
+            pitch = byte1;
+            rotating = true;
+        }
+
+        @Override
+        public void read(DataInputStream dis)
+            throws IOException
+        {
+            super.read(dis);
+            yaw = dis.readByte();
+            pitch = dis.readByte();
+        }
+
+        @Override
+        public void write(DataOutputStream dos)
+            throws IOException
+        {
+            super.write(dos);
+            dos.writeByte(yaw);
+            dos.writeByte(pitch);
+        }
+
+        @Override
+        public int getEstimatedSize()
+        {
+            return 6;
+        }
+    }
+    public static class PosRot extends MoveEntityPacket
+    {
+
+        public PosRot()
+        {
+            rotating = true;
+        }
+
+        public PosRot(int i, byte byte0, byte byte1, byte byte2, byte byte3, byte byte4)
+        {
+            super(i);
+            x = byte0;
+            y = byte1;
+            z = byte2;
+            yaw = byte3;
+            pitch = byte4;
+            rotating = true;
+        }
+
+        @Override
+        public void read(DataInputStream dis)
+            throws IOException
+        {
+            super.read(dis);
+            x = dis.readByte();
+            y = dis.readByte();
+            z = dis.readByte();
+            yaw = dis.readByte();
+            pitch = dis.readByte();
+        }
+
+        @Override
+        public void write(DataOutputStream dos)
+            throws IOException
+        {
+            super.write(dos);
+            dos.writeByte(x);
+            dos.writeByte(y);
+            dos.writeByte(z);
+            dos.writeByte(yaw);
+            dos.writeByte(pitch);
+        }
+
+        @Override
+        public int getEstimatedSize()
+        {
+            return 9;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java b/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java
new file mode 100644
index 000000000..33765f9d1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java
@@ -0,0 +1,174 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class MovePlayerPacket extends Packet
+{
+    public double x;
+    public double y;
+    public double z;
+    public double yView;
+    public float yaw;
+    public float pitch;
+    public boolean onGround;
+    public boolean hasPosition;
+    public boolean hasRotation;
+    public MovePlayerPacket()
+    {
+    }
+
+    public MovePlayerPacket(boolean flag)
+    {
+        onGround = flag;
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleFlying(this);
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        onGround = dis.read() != 0;
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.write(onGround ? 1 : 0);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 1;
+    }
+
+    public static class Rot extends MovePlayerPacket
+    {
+        public Rot() {
+            this.hasRotation = true;
+        }
+
+        public Rot(final float yaw, final float pitch, final boolean onGround) {
+            this.yaw = yaw;
+            this.pitch = pitch;
+            this.onGround = onGround;
+            this.hasRotation = true;
+        }
+
+        @Override
+        public void read(final DataInputStream dataInputStream) throws IOException {
+            this.yaw = dataInputStream.readFloat();
+            this.pitch = dataInputStream.readFloat();
+            super.read(dataInputStream);
+        }
+
+        @Override
+        public void write(final DataOutputStream dataOutputStream) throws IOException {
+            dataOutputStream.writeFloat(this.yaw);
+            dataOutputStream.writeFloat(this.pitch);
+            super.write(dataOutputStream);
+        }
+
+        @Override
+        public int getEstimatedSize() {
+            return 9;
+        }
+    }
+
+    public static class Pos extends MovePlayerPacket
+    {
+        public Pos() {
+            this.hasPosition = true;
+        }
+
+        public Pos(final double x, final double y, final double yView, final double z, final boolean onGround) {
+            this.x = x;
+            this.y = y;
+            this.yView = yView;
+            this.z = z;
+            this.onGround = onGround;
+            this.hasPosition = true;
+        }
+
+        @Override
+        public void read(final DataInputStream dataInputStream) throws IOException {
+            this.x = dataInputStream.readDouble();
+            this.y = dataInputStream.readDouble();
+            this.yView = dataInputStream.readDouble();
+            this.z = dataInputStream.readDouble();
+            super.read(dataInputStream);
+        }
+
+        @Override
+        public void write(final DataOutputStream dataOutputStream) throws IOException {
+            dataOutputStream.writeDouble(this.x);
+            dataOutputStream.writeDouble(this.y);
+            dataOutputStream.writeDouble(this.yView);
+            dataOutputStream.writeDouble(this.z);
+            super.write(dataOutputStream);
+        }
+
+        @Override
+        public int getEstimatedSize() {
+            return 33;
+        }
+    }
+
+    public static class PosRot extends MovePlayerPacket
+    {
+        public PosRot() {
+            this.hasRotation = true;
+            this.hasPosition = true;
+        }
+
+        public PosRot(final double x, final double y, final double yView, final double z, final float yaw, final float pitch, final boolean onGround) {
+            this.x = x;
+            this.y = y;
+            this.yView = yView;
+            this.z = z;
+            this.yaw = yaw;
+            this.pitch = pitch;
+            this.onGround = onGround;
+            this.hasRotation = true;
+            this.hasPosition = true;
+        }
+
+        @Override
+        public void read(final DataInputStream dataInputStream) throws IOException {
+            this.x = dataInputStream.readDouble();
+            this.y = dataInputStream.readDouble();
+            this.yView = dataInputStream.readDouble();
+            this.z = dataInputStream.readDouble();
+            this.yaw = dataInputStream.readFloat();
+            this.pitch = dataInputStream.readFloat();
+            super.read(dataInputStream);
+        }
+
+        @Override
+        public void write(final DataOutputStream dataOutputStream) throws IOException {
+            dataOutputStream.writeDouble(this.x);
+            dataOutputStream.writeDouble(this.y);
+            dataOutputStream.writeDouble(this.yView);
+            dataOutputStream.writeDouble(this.z);
+            dataOutputStream.writeFloat(this.yaw);
+            dataOutputStream.writeFloat(this.pitch);
+            super.write(dataOutputStream);
+        }
+
+        @Override
+        public int getEstimatedSize() {
+            return 41;
+        }
+    }
+}
